diff -ur mpd-5.6/conf/dictionary.mpd mpd-5.6-lutz/conf/dictionary.mpd
--- mpd-5.6/conf/dictionary.mpd	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/conf/dictionary.mpd	2013-04-25 13:28:49.000000000 +0200
@@ -27,6 +27,7 @@
 ATTRIBUTE	mpd-iface-name	20	string
 ATTRIBUTE	mpd-iface-descr	21	string
 ATTRIBUTE	mpd-iface-group	22	string
+ATTRIBUTE	mpd-term-cause	23	string
 ATTRIBUTE	mpd-drop-user	154	integer
 
 END-VENDOR	mpd
diff -ur mpd-5.6/src/Makefile mpd-5.6-lutz/src/Makefile
--- mpd-5.6/src/Makefile	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/Makefile	2013-02-01 00:45:22.000000000 +0100
@@ -10,7 +10,7 @@
 PROG?=			mpd5
 PREFIX?=		/usr/local
 BINDIR?=		${PREFIX}/sbin
-VERSION=		5.6
+VERSION=		5.6-iks2
 NOMAN=
 NO_MAN=
 
diff -ur mpd-5.6/src/auth.c mpd-5.6-lutz/src/auth.c
--- mpd-5.6/src/auth.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/auth.c	2013-04-24 14:33:51.000000000 +0200
@@ -44,11 +44,11 @@
   static void		AuthTimeout(void *arg);
   static int		AuthGetExternalPassword(char * extcmd, char *authname,
 			    char *password, size_t passlen);
-  static void		AuthAsync(void *arg);
-  static void		AuthAsyncFinish(void *arg, int was_canceled);
+  static void		AuthAsync(int typ, void *arg);
+  static void		AuthAsyncFinish(int typ, void *arg, int was_canceled);
   static int		AuthPreChecks(AuthData auth);
-  static void		AuthAccount(void *arg);
-  static void		AuthAccountFinish(void *arg, int was_canceled);
+  static void		AuthAccount(int typ, void *arg);
+  static void		AuthAccountFinish(int typ, void *arg, int was_canceled);
   static void		AuthInternal(AuthData auth);
   static int		AuthExternal(AuthData auth);
   static int		AuthExternalAcct(AuthData auth);
@@ -154,6 +154,17 @@
     { 0,	0,			NULL		},
   };
 
+  static MsgHandler acct_queue, auth_queue;
+
+int
+AuthSetup()
+{
+   MsgParallelRegister(&acct_queue, AuthAccount, AuthAccountFinish);
+   MsgParallelRegister(&auth_queue, AuthAsync, AuthAsyncFinish);
+   return 0;
+}
+
+
 void
 ACLCopy(struct acl *src, struct acl **dst)
 {
@@ -313,10 +324,10 @@
 {
     Auth	a = &l->lcp.auth;
   
-    if (a->thread)
-	paction_cancel(&a->thread);
-    if (a->acct_thread)
-	paction_cancel(&a->acct_thread);
+    if (a->auth_msg)
+	MsgAsyncCancel(&a->auth_msg);
+    if (a->acct_msg)
+	MsgAsyncCancel(&a->acct_msg);
     Freee(a->conf.extauth_script);
     Freee(a->conf.extacct_script);
 }
@@ -439,7 +450,7 @@
 
   /* Sanity check */
   if (l->lcp.phase != PHASE_AUTHENTICATE && l->lcp.phase != PHASE_NETWORK) {
-    Log(LG_AUTH, ("[%s] AUTH: rec'd stray packet", l->name));
+    Log(LG_ERR|LG_AUTH, ("[%s] AUTH: rec'd stray packet", l->name));
     mbfree(bp);
     return;
   }
@@ -448,7 +459,7 @@
 
   /* Sanity check length */
   if (len < sizeof(fsmh)) {
-    Log(LG_AUTH, ("[%s] AUTH: rec'd runt packet: %d bytes",
+    Log(LG_ERR|LG_AUTH, ("[%s] AUTH: rec'd runt packet: %d bytes",
       l->name, len));
     mbfree(bp);
     return;
@@ -538,8 +549,10 @@
       ProtoName(proto), AuthCode(proto, code, buf, sizeof(buf)), id, plen));
   }
 
+  MUTEX_LOCK(gNgMutex);
   /* Send it out */
   NgFuncWritePppFrameLink(l, proto, bp);
+  MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
@@ -682,7 +695,7 @@
   PapStop(&a->pap);
   ChapStop(&a->chap);
   EapStop(&a->eap);
-  paction_cancel(&a->thread);
+  MsgAsyncCancel(&a->auth_msg);
 }
 
 /*
@@ -813,9 +826,9 @@
     AuthData		auth;
       
     /* maybe an outstanding thread is running */
-    if (a->acct_thread) {
+    if (a->acct_msg) {
 	if (type == AUTH_ACCT_START || type == AUTH_ACCT_STOP) {
-	    paction_cancel(&a->acct_thread);
+	    MsgAsyncCancel(&a->acct_msg);
 	} else {
 	    Log(LG_AUTH2, ("[%s] ACCT: Accounting thread is already running", 
     		l->name));
@@ -896,12 +909,7 @@
 	auth = AuthDataNew(l);
 	auth->acct_type = type;
 
-	if (paction_start(&a->acct_thread, &gGiantMutex, AuthAccount, 
-		AuthAccountFinish, auth) == -1) {
-	    Log(LG_ERR, ("[%s] ACCT: Couldn't start thread: %d", 
-    		l->name, errno));
-	    AuthDataDestroy(auth);
-	}
+        MsgAsyncSend(&a->acct_msg, &acct_queue, 0, auth);
     }
 
 }
@@ -931,7 +939,7 @@
  */
  
 static void
-AuthAccount(void *arg)
+AuthAccount(int typ, void *arg)
 {
     AuthData	const auth = (AuthData)arg;
     int		err = 0;
@@ -966,7 +974,7 @@
  */
  
 static void
-AuthAccountFinish(void *arg, int was_canceled)
+AuthAccountFinish(int typ, void *arg, int was_canceled)
 {
     AuthData		auth = (AuthData)arg;
     Link 		l;
@@ -991,7 +999,9 @@
     if (l == NULL) {
 	AuthDataDestroy(auth);
 	return;
-    }    
+    } else {
+        MsgFree(&l->lcp.auth.acct_msg);
+    }
 
     if (auth->drop_user && auth->acct_type != AUTH_ACCT_STOP) {
 	Log(LG_AUTH, ("[%s] ACCT: Link close requested by the accounting", 
@@ -1103,7 +1113,7 @@
     }
 
     /* Check if we are ready to process request. */
-    if (a->thread) {
+    if (a->auth_msg) {
 	auth->status = AUTH_STATUS_BUSY;
 	auth->finish(l, auth);
 	return;
@@ -1117,14 +1127,7 @@
 	return;
     }
 
-    if (paction_start(&a->thread, &gGiantMutex, AuthAsync, 
-	AuthAsyncFinish, auth) == -1) {
-	Log(LG_ERR, ("[%s] AUTH: Couldn't start thread: %d", 
-    	    l->name, errno));
-	auth->status = AUTH_STATUS_FAIL;
-	auth->why_fail = AUTH_FAIL_NOT_EXPECTED;
-	auth->finish(l, auth);
-    }
+    MsgAsyncSend(&a->auth_msg, &auth_queue, 0, auth);
 }
 
 /*
@@ -1135,7 +1138,7 @@
  */
  
 static void
-AuthAsync(void *arg)
+AuthAsync(int typ, void *arg)
 {
     AuthData	const auth = (AuthData)arg;
 
@@ -1145,7 +1148,7 @@
         auth->params.authentic = AUTH_CONF_EXT_AUTH;
 	Log(LG_AUTH, ("[%s] AUTH: Trying EXTERNAL", auth->info.lnkname));
 	if (AuthExternal(auth)) {
-	    Log(LG_AUTH, ("[%s] AUTH: EXTERNAL returned error",
+	    Log(LG_ERR|LG_AUTH, ("[%s] AUTH: EXTERNAL returned error",
     		auth->info.lnkname));
 	} else {
 	    Log(LG_AUTH, ("[%s] AUTH: EXTERNAL returned: %s",
@@ -1164,7 +1167,7 @@
 	auth->params.authentic = AUTH_CONF_RADIUS_AUTH;
 	Log(LG_AUTH, ("[%s] AUTH: Trying RADIUS", auth->info.lnkname));
 	if (RadiusAuthenticate(auth)) {
-	    Log(LG_AUTH, ("[%s] AUTH: RADIUS returned error",
+	    Log(LG_ERR|LG_AUTH, ("[%s] AUTH: RADIUS returned error",
     		auth->info.lnkname));
 	} else {
 	    Log(LG_AUTH, ("[%s] AUTH: RADIUS returned: %s", 
@@ -1236,7 +1239,7 @@
  */
  
 static void
-AuthAsyncFinish(void *arg, int was_canceled)
+AuthAsyncFinish(int typ, void *arg, int was_canceled)
 {
     AuthData	auth = (AuthData)arg;
     Link	l;
@@ -1705,7 +1708,7 @@
     }
 
     if (num >= gMaxLogins) {
-	Log(LG_AUTH, ("[%s] AUTH: Name: \"%s\" max. number of logins exceeded",
+	Log(LG_ERR|LG_AUTH, ("[%s] AUTH: Name: \"%s\" max. number of logins exceeded",
 	    auth->info.lnkname, auth->params.authname));
         auth->status = AUTH_STATUS_FAIL;
         auth->why_fail = AUTH_FAIL_INVALID_LOGIN;
@@ -2215,7 +2218,7 @@
 	    j = 0;
 	    SLIST_FOREACH(r1, &auth->params.routes, next) {
 	      if (!u_rangecompare(&r->dest, &r1->dest)) {
-	        Log(LG_AUTH, ("[%s] Ext-auth: Duplicate route", auth->info.lnkname));
+	        Log(LG_ERR|LG_AUTH, ("[%s] Ext-auth: Duplicate route", auth->info.lnkname));
 	        j = 1;
 	      }
 	    };
@@ -2242,7 +2245,7 @@
 	    j = 0;
 	    SLIST_FOREACH(r1, &auth->params.routes, next) {
 	      if (!u_rangecompare(&r->dest, &r1->dest)) {
-	        Log(LG_AUTH, ("[%s] Ext-auth: Duplicate route", auth->info.lnkname));
+	        Log(LG_ERR|LG_AUTH, ("[%s] Ext-auth: Duplicate route", auth->info.lnkname));
 	        j = 1;
 	      }
 	    };
diff -ur mpd-5.6/src/auth.h mpd-5.6-lutz/src/auth.h
--- mpd-5.6/src/auth.h	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/auth.h	2013-02-04 22:50:14.000000000 +0100
@@ -215,8 +215,8 @@
     struct papinfo	pap;		/* PAP state */
     struct chapinfo	chap;		/* CHAP state */
     struct eapinfo	eap;		/* EAP state */
-    struct paction	*thread;	/* async auth thread */
-    struct paction	*acct_thread;	/* async accounting auth thread */
+    Msg			auth_msg;	/* async auth */
+    Msg			acct_msg;	/* async accounting */
     struct authconf	conf;		/* Auth backends, RADIUS, etc. */
     struct authparams	params;		/* params to pass to from auth backend */
     struct ng_ppp_link_stat64	prev_stats;	/* Previous link statistics */
@@ -287,6 +287,7 @@
  * FUNCTIONS
  */
 
+  extern int		AuthSetup(void);
   extern void		AuthInit(Link l);
   extern void		AuthInst(Auth auth, Auth autht);
   extern void		AuthShutdown(Link l);
diff -ur mpd-5.6/src/bund.c mpd-5.6-lutz/src/bund.c
--- mpd-5.6/src/bund.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/bund.c	2013-03-30 23:51:16.000000000 +0100
@@ -355,8 +355,10 @@
 	b->originate = l->originate;
     }
 
+    MUTEX_LOCK(gNgMutex);
     /* Update PPP node configuration */
     NgFuncSetConfig(b);
+    MUTEX_UNLOCK(gNgMutex);
 
     /* copy msession_id to link */
     strlcpy(l->msession_id, b->msession_id, sizeof(l->msession_id));
@@ -379,6 +381,12 @@
 
     AuthAccountStart(l, AUTH_ACCT_START);
 
+    if (Enabled(&gGlobalConf.options, GLOBAL_CONF_DELAYEDONESHOT) &&
+       !Enabled(&gGlobalConf.options, GLOBAL_CONF_ONESHOT)) {
+       /* enable one-shot, because real work started */
+       Enable(&gGlobalConf.options, GLOBAL_CONF_ONESHOT);
+    }
+
     return(b->n_up);
 }
 
@@ -400,10 +408,12 @@
 
     AuthAccountStart(l, AUTH_ACCT_STOP);
 
+    MUTEX_LOCK(gNgMutex);
     /* Disable link */
     b->pppConfig.links[l->bundleIndex].enableLink = 0;
     b->pppConfig.links[l->bundleIndex].mru = LCP_DEFAULT_MRU;
     NgFuncSetConfig(b);
+    MUTEX_UNLOCK(gNgMutex);
 
     LinkNgLeave(l);
     l->joined_bund = 0;
@@ -1106,7 +1116,7 @@
 	REF(b);
 
 	/* Get message channel */
-	MsgRegister(&b->msgs, BundMsg);
+	MsgSerialRegister(&b->msgs, BundMsg);
 
 	/* Initialize bundle configuration */
 	b->conf.retry_timeout = BUND_DEFAULT_RETRY;
@@ -1377,6 +1387,7 @@
     l = 0;
 #endif
 
+  MUTEX_LOCK(gNgMutex);
 #ifndef NG_PPP_STATS64
   if (NgFuncGetStats(b, l, &stats) != -1) {
     b->stats.xmitFrames += abs(stats.xmitFrames - b->oldStats.xmitFrames);
@@ -1393,6 +1404,7 @@
 #else
     NgFuncGetStats64(b, l, &b->stats);
 #endif
+  MUTEX_UNLOCK(gNgMutex);
 }
 
 /* 
@@ -1419,11 +1431,13 @@
 void
 BundResetStats(Bund b)
 {
+  MUTEX_LOCK(gNgMutex);
   NgFuncClrStats(b, NG_PPP_BUNDLE_LINKNUM);
   memset(&b->stats, 0, sizeof(b->stats));
 #ifndef NG_PPP_STATS64
   memset(&b->oldStats, 0, sizeof(b->oldStats));
 #endif
+  MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
@@ -1544,11 +1558,13 @@
 
 	    struct ng_ppp_link_stat	oldStats;
 	
+	    MUTEX_LOCK(gNgMutex);
 	    /* Get updated link traffic statistics */
 	    oldStats = l->bm.idleStats;
 	    NgFuncGetStats(l->bund, l->bundleIndex, &l->bm.idleStats);
 	    b->bm.traffic[0][0] += l->bm.idleStats.recvOctets - oldStats.recvOctets;
 	    b->bm.traffic[1][0] += l->bm.idleStats.xmitOctets - oldStats.xmitOctets;
+	    MUTEX_UNLOCK(gNgMutex);
 	}
     }
 
@@ -1669,6 +1685,7 @@
     int			newIface = 0;
     int			newPpp = 0;
 
+    MUTEX_LOCK(gNgMutex);
     /* Create new iface node */
     if (NgFuncCreateIface(b,
 	b->iface.ifname, sizeof(b->iface.ifname)) < 0) {
@@ -1708,10 +1725,12 @@
 	goto fail;
     }
 
+    MUTEX_UNLOCK(gNgMutex);
     /* OK */
     return(0);
 
 fail:
+    MUTEX_UNLOCK(gNgMutex);
     BundNgShutdown(b, newIface, newPpp);
     return(-1);
 }
@@ -1725,6 +1744,7 @@
 {
     char	path[NG_PATHSIZ];
 
+    MUTEX_LOCK(gNgMutex);
     if (iface) {
 	snprintf(path, sizeof(path), "%s:", b->iface.ngname);
 	NgFuncShutdownNode(gLinksCsock, b->name, path);
@@ -1734,6 +1754,7 @@
 	NgFuncShutdownNode(gLinksCsock, b->name, path);
     }
     b->hook[0] = 0;
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
diff -ur mpd-5.6/src/ccp.c mpd-5.6-lutz/src/ccp.c
--- mpd-5.6/src/ccp.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/ccp.c	2013-03-28 16:52:28.000000000 +0100
@@ -165,14 +165,17 @@
 {
     char	name[NG_NODESIZ];
 
+    MUTEX_LOCK(gNgMutex);
     /* Create a netgraph socket node */
     snprintf(name, sizeof(name), "mpd%d-cso", gPid);
     if (NgMkSockNode(name, &gCcpCsock, &gCcpDsock) < 0) {
 	Perror("CcpsInit(): can't create %s node", NG_SOCKET_NODE_TYPE);
+        MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
     (void) fcntl(gCcpCsock, F_SETFD, 1);
     (void) fcntl(gCcpDsock, F_SETFD, 1);
+    MUTEX_UNLOCK(gNgMutex);
 
     /* Listen for happenings on our node */
     EventRegister(&gCcpCtrlEvent, EVENT_READ,
@@ -315,11 +318,14 @@
     int			i, len;
     ng_ID_t		id;
 
+    MUTEX_LOCK(gNgMutex);
     /* Read message */
     if ((len = NgRecvMsg(gCcpCsock, &u.msg, sizeof(u), raddr)) < 0) {
 	Perror("CcpNgCtrlEvent: can't read message");
+        MUTEX_UNLOCK(gNgMutex);
 	return;
     }
+    MUTEX_UNLOCK(gNgMutex);
     
     if (sscanf(raddr, "[%x]:", &id) != 1) {
 	Log(LG_ERR, ("CcpNgCtrlEvent: can't decode sender id: '%s'",
@@ -424,8 +430,11 @@
 	    /* Packet requiring decompression */
 	    bp = CcpDataInput(b, bp);
 	}
-	if (bp)
+	if (bp) {
+	    MUTEX_LOCK(gNgMutex);
 	    NgFuncWriteFrame(gCcpDsock, naddr.sg_data, b->name, bp);
+	    MUTEX_UNLOCK(gNgMutex);
+	}
     }
 }
 
@@ -802,6 +811,7 @@
     return;
   }
 
+  MUTEX_LOCK(gNgMutex);
   if (ccp->xmit != NULL && ccp->xmit->Compress != NULL) {
     /* Connect a hook from the ppp node to our socket node */
     snprintf(cn.path, sizeof(cn.path), "[%x]:", b->nodeID);
@@ -837,6 +847,8 @@
   b->pppConfig.bund.enableDecompression = (ccp->recv != NULL)?ccp->recv->mode:0;
   NgFuncSetConfig(b);
 
+  MUTEX_UNLOCK(gNgMutex);
+
   /* Update interface MTU */
   BundUpdateParams(b);
 }
@@ -851,14 +863,17 @@
     Bund 	b = (Bund)fp->arg;
   CcpState	const ccp = &b->ccp;
 
+  MUTEX_LOCK(gNgMutex);
   /* Update PPP node config */
   b->pppConfig.bund.enableCompression = 0;
   b->pppConfig.bund.enableDecompression = 0;
   NgFuncSetConfig(b);
+  MUTEX_UNLOCK(gNgMutex);
 
   /* Update interface MTU */
   BundUpdateParams(b);
   
+  MUTEX_LOCK(gNgMutex);
   if (ccp->xmit != NULL && ccp->xmit->Compress != NULL) {
     char	hook[NG_HOOKSIZ];
     /* Disconnect hook. */
@@ -879,6 +894,7 @@
 
   ccp->xmit_resets = 0;
   ccp->recv_resets = 0;
+  MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
diff -ur mpd-5.6/src/ccp_deflate.c mpd-5.6-lutz/src/ccp_deflate.c
--- mpd-5.6/src/ccp_deflate.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/ccp_deflate.c	2013-03-28 16:52:13.000000000 +0100
@@ -75,6 +75,7 @@
     const char		*deflatehook, *ppphook;
     ng_ID_t		id;
 
+    MUTEX_LOCK(gNgMutex);
     /* Initialize configuration structure */
     memset(&conf, 0, sizeof(conf));
     conf.enable = 1;
@@ -96,6 +97,7 @@
     if (NgSendMsg(gCcpCsock, path,
     	    NGM_GENERIC_COOKIE, NGM_MKPEER, &mp, sizeof(mp)) < 0) {
 	Perror("[%s] can't create %s node", b->name, mp.type);
+        MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
@@ -115,9 +117,11 @@
 	Perror("[%s] can't config %s node at %s",
     	    b->name, NG_DEFLATE_NODE_TYPE, path);
 	NgFuncShutdownNode(gCcpCsock, b->name, path);
+        MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
+    MUTEX_UNLOCK(gNgMutex);
     return 0;
 }
 
@@ -170,6 +174,7 @@
 {
     char		path[NG_PATHSIZ];
 
+    MUTEX_LOCK(gNgMutex);
     /* Remove node */
     if (dir == COMP_DIR_XMIT) {
 	snprintf(path, sizeof(path), "[%x]:", b->ccp.comp_node_id);
@@ -179,6 +184,7 @@
 	b->ccp.decomp_node_id = 0;
     }
     NgFuncShutdownNode(gCcpCsock, b->name, path);
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
@@ -189,12 +195,14 @@
 DeflateRecvResetReq(Bund b, int id, Mbuf bp, int *noAck)
 {
     char		path[NG_PATHSIZ];
+    MUTEX_LOCK(gNgMutex);
     /* Forward ResetReq to the DEFLATE compression node */
     snprintf(path, sizeof(path), "[%x]:", b->ccp.comp_node_id);
     if (NgSendMsg(gCcpCsock, path,
     	    NGM_DEFLATE_COOKIE, NGM_DEFLATE_RESETREQ, NULL, 0) < 0) {
 	Perror("[%s] reset-req to %s node", b->name, NG_DEFLATE_NODE_TYPE);
     }
+    MUTEX_UNLOCK(gNgMutex);
     return(NULL);
 }
 
@@ -216,12 +224,14 @@
 DeflateRecvResetAck(Bund b, int id, Mbuf bp)
 {
     char		path[NG_PATHSIZ];
+    MUTEX_LOCK(gNgMutex);
     /* Forward ResetReq to the DEFLATE compression node */
     snprintf(path, sizeof(path), "[%x]:", b->ccp.decomp_node_id);
     if (NgSendMsg(gCcpCsock, path,
     	    NGM_DEFLATE_COOKIE, NGM_DEFLATE_RESETREQ, NULL, 0) < 0) {
 	Perror("[%s] reset-ack to %s node", b->name, NG_DEFLATE_NODE_TYPE);
     }
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
@@ -341,11 +351,14 @@
 	default:
 	    assert(0);
     }
+    MUTEX_LOCK(gNgMutex);
     if (NgFuncSendQuery(path, NGM_DEFLATE_COOKIE, NGM_DEFLATE_GET_STATS, NULL, 0, 
 	&u.reply, sizeof(u), NULL) < 0) {
 	    Perror("[%s] can't get %s stats", b->name, NG_DEFLATE_NODE_TYPE);
+            MUTEX_UNLOCK(gNgMutex);
 	    return(0);
     }
+    MUTEX_UNLOCK(gNgMutex);
     memcpy(&stats, u.reply.data, sizeof(stats));
     switch (dir) {
 	case COMP_DIR_XMIT:
diff -ur mpd-5.6/src/ccp_mppc.c mpd-5.6-lutz/src/ccp_mppc.c
--- mpd-5.6/src/ccp_mppc.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/ccp_mppc.c	2013-03-28 16:51:57.000000000 +0100
@@ -184,6 +184,7 @@
         }
     }
 
+    MUTEX_LOCK(gNgMutex);
     /* Attach a new MPPC node to the PPP node */
     snprintf(path, sizeof(path), "[%x]:", b->nodeID);
     strcpy(mp.type, NG_MPPC_NODE_TYPE);
@@ -192,6 +193,7 @@
     if (NgSendMsg(gCcpCsock, path,
 	    NGM_GENERIC_COOKIE, NGM_MKPEER, &mp, sizeof(mp)) < 0) {
 	Perror("[%s] can't create %s node", b->name, mp.type);
+        MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
@@ -211,9 +213,12 @@
 	Perror("[%s] can't config %s node at %s",
     	    b->name, NG_MPPC_NODE_TYPE, path);
 	NgFuncShutdownNode(gCcpCsock, b->name, path);
+        MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
+    MUTEX_UNLOCK(gNgMutex);
+
     /* Done */
     return(0);
 }
@@ -331,7 +336,9 @@
 	snprintf(path, sizeof(path), "[%x]:", b->ccp.decomp_node_id);
 	b->ccp.decomp_node_id = 0;
     }
+    MUTEX_LOCK(gNgMutex);
     NgFuncShutdownNode(gCcpCsock, b->name, path);
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
@@ -489,12 +496,14 @@
 MppcRecvResetReq(Bund b, int id, Mbuf bp, int *noAck)
 {
     char		path[NG_PATHSIZ];
+    MUTEX_LOCK(gNgMutex);
     /* Forward ResetReq to the MPPC compression node */
     snprintf(path, sizeof(path), "[%x]:", b->ccp.comp_node_id);
     if (NgSendMsg(gCcpCsock, path,
     	    NGM_MPPC_COOKIE, NGM_MPPC_RESETREQ, NULL, 0) < 0) {
 	Perror("[%s] reset-req to %s node", b->name, NG_MPPC_NODE_TYPE);
     }
+    MUTEX_UNLOCK(gNgMutex);
 
     /* No ResetAck required for MPPC */
     if (noAck)
@@ -750,9 +759,11 @@
     struct ngm_mkpeer		mp;
     int				cs, ds;
 
+    MUTEX_LOCK(gNgMutex);
     /* Create a netgraph socket node */
     if (NgMkSockNode(NULL, &cs, &ds) < 0) {
 	Perror("MppcTestCap: can't create socket node");
+        MUTEX_UNLOCK(gNgMutex);
     	return(-1);
     }
 
@@ -795,6 +806,7 @@
 done:
     close(cs);
     close(ds);
+    MUTEX_UNLOCK(gNgMutex);
     return(0);
 }
 
diff -ur mpd-5.6/src/ccp_pred1.c mpd-5.6-lutz/src/ccp_pred1.c
--- mpd-5.6/src/ccp_pred1.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/ccp_pred1.c	2013-03-28 16:51:46.000000000 +0100
@@ -139,6 +139,7 @@
         pred1hook = NG_PRED1_HOOK_DECOMP;
     }
 
+    MUTEX_LOCK(gNgMutex);
     /* Attach a new PRED1 node to the PPP node */
     snprintf(path, sizeof(path), "[%x]:", b->nodeID);
     strcpy(mp.type, NG_PRED1_NODE_TYPE);
@@ -147,6 +148,7 @@
     if (NgSendMsg(gCcpCsock, path,
     	    NGM_GENERIC_COOKIE, NGM_MKPEER, &mp, sizeof(mp)) < 0) {
 	Perror("[%s] can't create %s node", b->name, mp.type);
+        MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
@@ -166,8 +168,10 @@
 	Perror("[%s] can't config %s node at %s",
     	    b->name, NG_PRED1_NODE_TYPE, path);
 	NgFuncShutdownNode(gCcpCsock, b->name, path);
+        MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
+    MUTEX_UNLOCK(gNgMutex);
 #endif
     return 0;
 }
@@ -204,7 +208,9 @@
 	snprintf(path, sizeof(path), "[%x]:", b->ccp.decomp_node_id);
 	b->ccp.decomp_node_id = 0;
     }
+    MUTEX_LOCK(gNgMutex);
     NgFuncShutdownNode(gCcpCsock, b->name, path);
+    MUTEX_UNLOCK(gNgMutex);
 #endif
 }
 
@@ -384,12 +390,14 @@
   p->xmit_stats.Errors++;
 #else
     char		path[NG_PATHSIZ];
+    MUTEX_LOCK(gNgMutex);
     /* Forward ResetReq to the Predictor1 compression node */
     snprintf(path, sizeof(path), "[%x]:", b->ccp.comp_node_id);
     if (NgSendMsg(gCcpCsock, path,
     	    NGM_PRED1_COOKIE, NGM_PRED1_RESETREQ, NULL, 0) < 0) {
 	Perror("[%s] reset to %s node", b->name, NG_PRED1_NODE_TYPE);
     }
+    MUTEX_UNLOCK(gNgMutex);
 #endif
 return(NULL);
 }
@@ -418,12 +426,14 @@
     Pred1Init(b, COMP_DIR_RECV);
 #else
     char		path[NG_PATHSIZ];
+    MUTEX_LOCK(gNgMutex);
     /* Forward ResetReq to the Predictor1 decompression node */
     snprintf(path, sizeof(path), "[%x]:", b->ccp.decomp_node_id);
     if (NgSendMsg(gCcpCsock, path,
     	    NGM_PRED1_COOKIE, NGM_PRED1_RESETREQ, NULL, 0) < 0) {
 	Perror("[%s] reset to %s node", b->name, NG_PRED1_NODE_TYPE);
     }
+    MUTEX_UNLOCK(gNgMutex);
 #endif
 }
 
@@ -539,11 +549,14 @@
 	default:
 	    assert(0);
     }
+    MUTEX_LOCK(gNgMutex);
     if (NgFuncSendQuery(path, NGM_PRED1_COOKIE, NGM_PRED1_GET_STATS, NULL, 0, 
 	&u.reply, sizeof(u), NULL) < 0) {
 	    Perror("[%s] can't get %s stats", b->name, NG_PRED1_NODE_TYPE);
+            MUTEX_UNLOCK(gNgMutex);
 	    return(0);
     }
+    MUTEX_UNLOCK(gNgMutex);
     memcpy(&stats, u.reply.data, sizeof(stats));
     switch (dir) {
 	case COMP_DIR_XMIT:
diff -ur mpd-5.6/src/command.c mpd-5.6-lutz/src/command.c
--- mpd-5.6/src/command.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/command.c	2013-04-22 00:20:51.000000000 +0200
@@ -75,6 +75,7 @@
     SET_L2TPLIMIT,
 #endif
     SET_MAX_CHILDREN,
+    SET_QUEUE_DELAY,
 #ifdef USE_NG_BPF
     SET_FILTER
 #endif
@@ -148,6 +149,8 @@
 #endif
     { "max-children {num}",		"Max number of children",
 	GlobalSetCommand, NULL, 2, (void *) SET_MAX_CHILDREN },
+    { "queue-delay {num}",		"Delay in milliseconds in message queue processing",
+	GlobalSetCommand, NULL, 2, (void *) SET_QUEUE_DELAY },
 #ifdef USE_NG_BPF
     { "filter {num} add|clear [\"{flt}\"]",	"Global traffic filters management",
 	GlobalSetCommand, NULL, 2, (void *) SET_FILTER },
@@ -160,6 +163,7 @@
     { 0,	GLOBAL_CONF_TCPWRAPPER,	"tcp-wrapper"	},
 #endif
     { 0,	GLOBAL_CONF_ONESHOT,	"one-shot"	},
+    { 0,	GLOBAL_CONF_DELAYEDONESHOT,	"delayed-one-shot"	},
     { 0,	0,			NULL		},
   };
 
@@ -682,6 +686,14 @@
 	    gMaxChildren = val;
       break;
 
+    case SET_QUEUE_DELAY:
+	val = atoi(*av);
+	if (val < 0 || val > 120)
+	    Error("Incorrect delay time.");
+	else
+	    gQueueDelay = val;
+      break;
+
 #ifdef USE_NG_BPF
     case SET_FILTER:
 	if (ac == 4 && strcasecmp(av[1], "add") == 0) {
@@ -937,6 +949,7 @@
     Printf("	pptplimit	: %d\r\n", gPPTPtunlimit);
 #endif
     Printf("	max-children	: %d\r\n", gMaxChildren);
+    Printf("	queue-delay (ms): %d\r\n", gQueueDelay);
     Printf("Global options:\r\n");
     OptStat(ctx, &gGlobalConf.options, gGlobalConfList);
 #ifdef USE_NG_BPF
diff -ur mpd-5.6/src/command.h mpd-5.6-lutz/src/command.h
--- mpd-5.6/src/command.h	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/command.h	2013-03-29 17:52:36.000000000 +0100
@@ -31,7 +31,8 @@
 #ifdef USE_WRAP
     GLOBAL_CONF_TCPWRAPPER,	/* enable tcp-wrapper */
 #endif
-    GLOBAL_CONF_ONESHOT		/* enable OneShot mode */
+    GLOBAL_CONF_ONESHOT,	/* enable OneShot mode */
+    GLOBAL_CONF_DELAYEDONESHOT	/* enable DelayedOneShot mode */
   };
 
   struct globalconf {
diff -ur mpd-5.6/src/eap.c mpd-5.6-lutz/src/eap.c
--- mpd-5.6/src/eap.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/eap.c	2013-03-28 16:51:33.000000000 +0100
@@ -510,8 +510,10 @@
       l->name, EapCode(f->code, buf, sizeof(buf)), f->id, htons(f->length)));
   } 
 
+  MUTEX_LOCK(gNgMutex);
   bp = mbcopyback(NULL, 0, a->params.eapmsg, a->params.eapmsg_len);
   NgFuncWritePppFrameLink(l, PROTO_EAP, bp);
+  MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
diff -ur mpd-5.6/src/ecp.c mpd-5.6-lutz/src/ecp.c
--- mpd-5.6/src/ecp.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/ecp.c	2013-03-28 16:51:26.000000000 +0100
@@ -168,14 +168,17 @@
 {
     char	name[NG_NODESIZ];
 
+    MUTEX_LOCK(gNgMutex);
     /* Create a netgraph socket node */
     snprintf(name, sizeof(name), "mpd%d-eso", gPid);
     if (NgMkSockNode(name, &gEcpCsock, &gEcpDsock) < 0) {
 	Perror("EcpsInit(): can't create %s node", NG_SOCKET_NODE_TYPE);
+        MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
     (void) fcntl(gEcpCsock, F_SETFD, 1);
     (void) fcntl(gEcpDsock, F_SETFD, 1);
+    MUTEX_UNLOCK(gNgMutex);
 
     /* Listen for happenings on our node */
     EventRegister(&gEcpDataEvent, EVENT_READ,
@@ -353,8 +356,11 @@
 	    /* Packet requiring decompression */
 	    bp = EcpDataInput(b, bp);
 	}
-	if (bp)
+	if (bp) {
+	    MUTEX_LOCK(gNgMutex);
 	    NgFuncWriteFrame(gEcpDsock, naddr.sg_data, b->name, bp);
+	    MUTEX_UNLOCK(gNgMutex);
+	}
     }
 }
 
@@ -638,6 +644,7 @@
   EcpState	const ecp = &b->ecp;
   struct ngm_connect    cn;
 
+  MUTEX_LOCK(gNgMutex);
   /* Initialize */
   if (ecp->xmit && ecp->xmit->Init)
     (*ecp->xmit->Init)(b, ECP_DIR_XMIT);
@@ -676,6 +683,7 @@
   b->pppConfig.bund.enableEncryption = (ecp->xmit != NULL);
   b->pppConfig.bund.enableDecryption = (ecp->recv != NULL);
   NgFuncSetConfig(b);
+  MUTEX_UNLOCK(gNgMutex);
 
   /* Update interface MTU */
   BundUpdateParams(b);
@@ -693,14 +701,17 @@
     Bund 	b = (Bund)fp->arg;
   EcpState	const ecp = &b->ecp;
 
+  MUTEX_LOCK(gNgMutex);
   /* Update PPP node config */
   b->pppConfig.bund.enableEncryption = 0;
   b->pppConfig.bund.enableDecryption = 0;
   NgFuncSetConfig(b);
+  MUTEX_UNLOCK(gNgMutex);
 
   /* Update interface MTU */
   BundUpdateParams(b);
 
+  MUTEX_LOCK(gNgMutex);
   if (ecp->xmit != NULL && ecp->xmit->Encrypt != NULL) {
     char	hook[NG_HOOKSIZ];
     /* Disconnect hook. */
@@ -722,6 +733,7 @@
     
   ecp->xmit_resets = 0;
   ecp->recv_resets = 0;
+  MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
diff -ur mpd-5.6/src/fsm.c mpd-5.6-lutz/src/fsm.c
--- mpd-5.6/src/fsm.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/fsm.c	2013-03-28 16:51:09.000000000 +0100
@@ -227,12 +227,14 @@
     /* Prepend to payload */
     bp = mbcopyback(payload, -(int)sizeof(hdr), &hdr, sizeof(hdr));
 
+    MUTEX_LOCK(gNgMutex);
     /* Send it out */
     if (fp->type->link_layer) {
 	NgFuncWritePppFrameLink((Link)fp->arg, fp->type->proto, bp);
     } else {
 	NgFuncWritePppFrame(b, NG_PPP_BUNDLE_LINKNUM, fp->type->proto, bp);
     }
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
@@ -1404,6 +1406,7 @@
 	return;
     }
 
+    MUTEX_LOCK(gNgMutex);
     /* See if there was any traffic since last time */
     oldStats = fp->idleStats;
     NgFuncGetStats(b, l ?
@@ -1412,6 +1415,7 @@
 	fp->quietCount = 0;
     else
 	fp->quietCount++;
+    MUTEX_UNLOCK(gNgMutex);
 
     /* See if peer hasn't responded for too many requests */
     switch (fp->quietCount) {
